/**
 * @author Nashorn74@yahoo.co.kr
 */
 
var Main = { }

var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();

Main.onLoad = function() 
{ 
    alert("Main.onLoad()"); 
    
    widgetAPI.sendReadyEvent();
    document.getElementById("anchor").focus();
    
    Main.loadWeatherInfo();
}

Main.onUnload = function()
{ 
    alert("Main.onUnload()");
}

Main.loadWeatherInfo = function()
{
    var objectKeywordList = new Array();
    
    objectKeywordList[0] = document.getElementById("area");
    objectKeywordList[1] = document.getElementById("date");
    objectKeywordList[2] = document.getElementById("weather");
    objectKeywordList[3] = document.getElementById("temp");
    objectKeywordList[4] = document.getElementById("humidity");
    objectKeywordList[5] = document.getElementById("wind");
    objectKeywordList[6] = document.getElementById("icon");

    var query_url = "http://www.google.com/ig/api?hl=ko&weather=seoul";

    alert("Making request for data");
    
    xhr=new XMLHttpRequest();   
    xhr.open("GET", query_url, false);      
    xhr.send();   
    
    // results   
    xmlDoc=xhr.responseXML;    
    alert('Response received, now parsing');
    
    var results=xmlDoc.getElementsByTagName("weather");   
    var results_display = '';
    
    for(i=0; i<results.length; i++) 
    {
        var bindings=results[i].getElementsByTagName("forecast_information");
        for (j=0; j<bindings.length; j++)
        {
            if (bindings[j].getElementsByTagName("city").length > 0) 
            {
                var areaString = bindings[j].getElementsByTagName("city")[0].getAttribute("data");
                objectKeywordList[0].innerText = "지역: "+areaString;
            }
            
            if (bindings[j].getElementsByTagName("forecast_date").length > 0) 
            {
                var dateString = bindings[j].getElementsByTagName("forecast_date")[0].getAttribute("data");
                objectKeywordList[1].innerText = "날짜: "+dateString;
            }
        }
        
        var bindings=results[i].getElementsByTagName("current_conditions");
        for (j=0; j<bindings.length; j++)
        {
            if (bindings[j].getElementsByTagName("condition").length > 0) 
            {
                var weatherString = bindings[j].getElementsByTagName("condition")[0].getAttribute("data");
                objectKeywordList[2].innerText = "날씨: "+weatherString;
            }
            
            if (bindings[j].getElementsByTagName("temp_c").length > 0) 
            {
                var tempString = bindings[j].getElementsByTagName("temp_c")[0].getAttribute("data");
                objectKeywordList[3].innerText = "온도: "+tempString;
            }
            
            if (bindings[j].getElementsByTagName("humidity").length > 0) 
            {
                var humidityString = bindings[j].getElementsByTagName("humidity")[0].getAttribute("data");
                objectKeywordList[4].innerText = humidityString;
            }
            
            if (bindings[j].getElementsByTagName("wind_condition").length > 0) 
            {
                var windString = bindings[j].getElementsByTagName("wind_condition")[0].getAttribute("data");
                objectKeywordList[5].innerText = windString;
            }
            
            if (bindings[j].getElementsByTagName("icon").length > 0) 
            {
                var iconString = bindings[j].getElementsByTagName("icon")[0].getAttribute("data");
                objectKeywordList[6].src = "http://www.google.com"+iconString;
            }
        }
    }
}

Main.keyDown = function()
{
    var keyCode = event.keyCode;
    alert("Main key code : "+keyCode);
    
    switch(keyCode)
    {
    case tvKey.KEY_RED:
        Main.loadWeatherInfo();
        break;
    }
}
