/**
 * @author Nashorn74@yahoo.co.kr
 */

var Main = { }

var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();

var cardImageArray = new Array();
var cardNumberArray = new Array();
var openCardArray = new Array();

var gameStep = -1;
var gameRemainTime = 60;
var firstOpenCard = -1;
var secondOpenCard = -1;

Main.onLoad = function() 
{ 
    alert("Main.onLoad()"); 
    
    widgetAPI.sendReadyEvent();
    document.getElementById("anchor").focus();
    
    
    ////
    
    gameStep = 0;
    gameRemainTime = 60;
    firstOpenCard = -1;
    secondOpenCard = -1;
    
    //////////////////////////////////////////////
    
    Main.clearCard();
    
    objectName = document.getElementById("game_remain_time");
    objectName.innerText = "남은 시간 : "+gameRemainTime+"초";
    
    //////////////////////////////////////////////
                    
    Main.startGame();
}

Main.onUnload = function()
{ 
    alert("Main.onUnload()");
}

Main.startGame = function()
{
    var objectImageList = new Array();
    objectImageList[0] = document.getElementById("game_card1");
    objectImageList[1] = document.getElementById("game_card2");
    objectImageList[2] = document.getElementById("game_card3");
    objectImageList[3] = document.getElementById("game_card4");
    objectImageList[4] = document.getElementById("game_card5");
    objectImageList[5] = document.getElementById("game_card6");
    objectImageList[6] = document.getElementById("game_card7");
    objectImageList[7] = document.getElementById("game_card8");
    objectImageList[8] = document.getElementById("game_card9");
    objectImageList[9] = document.getElementById("game_card10");
    
    var levelCardList = new Array();
    
    levelCardList[0] = "img/1_1.jpg";
    levelCardList[1] = "img/2_1.jpg";
    levelCardList[2] = "img/3_1.jpg";
    levelCardList[3] = "img/4_1.jpg";
    levelCardList[4] = "img/5_1.jpg";
    levelCardList[5] = "img/1_2.jpg";
    levelCardList[6] = "img/2_2.jpg";
    levelCardList[7] = "img/3_2.jpg";
    levelCardList[8] = "img/4_2.jpg";
    levelCardList[9] = "img/5_2.jpg";
    
    var numberCountList = new Array();
    for (i = 0; i < 5; i++)
    {
        numberCountList[i] = 0;
    }
    
    for (i = 0; i < 10; i++)
    {
        while(1)
        {
            var result = Math.floor(Math.random() * 5);
            
            if (numberCountList[result] < 2)
            {
                numberCountList[result]++;

                if (numberCountList[result] == 1)
                    cardImageArray[i] = levelCardList[result];
                else
                    cardImageArray[i] = levelCardList[result+5];
                cardNumberArray[i] = result;
                openCardArray[i] = 0;
                
                objectImageList[i].src = levelCardList[result];
                
                break;
            }
        }
    }
    
    setTimeout("Main.closeCard()", 1000);
}

Main.closeCard = function()
{
    Main.clearCard();
    
    //사용자가 입력할 수 있는 모드로 전환
    gameStep = 1;
    
    setTimeout("Main.gameTimer()", 1000);
}

Main.gameTimer = function()
{
    if (gameStep > 0 && gameStep < 3)
    {
        if (gameRemainTime > 0)
        {
            gameRemainTime--;
            
            objectName = document.getElementById("game_remain_time");
            objectName.innerText = "남은 시간 : "+gameRemainTime+"초";
            
            setTimeout("Main.gameTimer()", 1000);
        }
        else
        {
            Main.gameComplete();
        }
    }
}

Main.closeOpenCard = function()
{
    var objectImageList = new Array();
    objectImageList[0] = document.getElementById("game_card1");
    objectImageList[1] = document.getElementById("game_card2");
    objectImageList[2] = document.getElementById("game_card3");
    objectImageList[3] = document.getElementById("game_card4");
    objectImageList[4] = document.getElementById("game_card5");
    objectImageList[5] = document.getElementById("game_card6");
    objectImageList[6] = document.getElementById("game_card7");
    objectImageList[7] = document.getElementById("game_card8");
    objectImageList[8] = document.getElementById("game_card9");
    objectImageList[9] = document.getElementById("game_card10");
    
    var levelCardList = new Array();
    levelCardList[0] = "img/cardback1.jpg";
    levelCardList[1] = "img/cardback2.jpg";
    levelCardList[2] = "img/cardback3.jpg";
    levelCardList[3] = "img/cardback4.jpg";
    levelCardList[4] = "img/cardback5.jpg";
    levelCardList[5] = "img/cardback6.jpg";
    levelCardList[6] = "img/cardback7.jpg";
    levelCardList[7] = "img/cardback8.jpg";
    levelCardList[8] = "img/cardback9.jpg";
    levelCardList[9] = "img/cardback10.jpg";
                    
    gameStep = 1;
    openCardArray[firstOpenCard] = 0;
    openCardArray[secondOpenCard] = 0;
    objectImageList[firstOpenCard].src = levelCardList[firstOpenCard]
    objectImageList[secondOpenCard].src = levelCardList[secondOpenCard]

    firstOpenCard = -1;
    secondOpenCard = -1;
    
    if (gameRemainTime > 0)
    {
        gameRemainTime--;
        
        objectName = document.getElementById("game_remain_time");
        objectName.innerText = "남은 시간 : "+gameRemainTime+"초";
        
        setTimeout("Main.gameTimer()", 1000);
    }
    else
    {
        Main.gameComplete();
    }
}

Main.gameComplete = function()
{
    gameStep = 0;
    gameRemainTime = 60;
    firstOpenCard = -1;
    secondOpenCard = -1;
    
    //////////////////////////////////////////////
    
    Main.clearCard();
    
    objectName = document.getElementById("game_remain_time");
    objectName.innerText = "남은 시간 : "+gameRemainTime+"초";
    
    //////////////////////////////////////////////
    
    setTimeout("Main.startGame()", 1000);       
}

Main.clearCard = function()
{
    var objectImageList = new Array();
    objectImageList[0] = document.getElementById("game_card1");
    objectImageList[1] = document.getElementById("game_card2");
    objectImageList[2] = document.getElementById("game_card3");
    objectImageList[3] = document.getElementById("game_card4");
    objectImageList[4] = document.getElementById("game_card5");
    objectImageList[5] = document.getElementById("game_card6");
    objectImageList[6] = document.getElementById("game_card7");
    objectImageList[7] = document.getElementById("game_card8");
    objectImageList[8] = document.getElementById("game_card9");
    objectImageList[9] = document.getElementById("game_card10");
    
    var levelCardList = new Array();
    levelCardList[0] = "img/cardback1.jpg";
    levelCardList[1] = "img/cardback2.jpg";
    levelCardList[2] = "img/cardback3.jpg";
    levelCardList[3] = "img/cardback4.jpg";
    levelCardList[4] = "img/cardback5.jpg";
    levelCardList[5] = "img/cardback6.jpg";
    levelCardList[6] = "img/cardback7.jpg";
    levelCardList[7] = "img/cardback8.jpg";
    levelCardList[8] = "img/cardback9.jpg";
    levelCardList[9] = "img/cardback10.jpg";
    
    for (i = 0; i < 10; i++)
    {
        objectImageList[i].src = levelCardList[i];
    }
}

Main.keyDown = function()
{
    var keyCode = event.keyCode;
    alert("Main key code : "+keyCode);
    
    switch(keyCode)
    {
    case tvKey.KEY_1:
    case tvKey.KEY_2:
    case tvKey.KEY_3:
    case tvKey.KEY_4:
    case tvKey.KEY_5:
    case tvKey.KEY_6:
    case tvKey.KEY_7:
    case tvKey.KEY_8:
    case tvKey.KEY_9:
    case tvKey.KEY_0:
        if (gameStep > 0 && gameStep < 3)
        {
            alert("step check!!!");
            
            var objectImageList = new Array();
            objectImageList[0] = document.getElementById("game_card1");
            objectImageList[1] = document.getElementById("game_card2");
            objectImageList[2] = document.getElementById("game_card3");
            objectImageList[3] = document.getElementById("game_card4");
            objectImageList[4] = document.getElementById("game_card5");
            objectImageList[5] = document.getElementById("game_card6");
            objectImageList[6] = document.getElementById("game_card7");
            objectImageList[7] = document.getElementById("game_card8");
            objectImageList[8] = document.getElementById("game_card9");
            objectImageList[9] = document.getElementById("game_card10");
            
            var levelCardList = new Array();
            levelCardList[0] = "img/cardback1.jpg";
            levelCardList[1] = "img/cardback2.jpg";
            levelCardList[2] = "img/cardback3.jpg";
            levelCardList[3] = "img/cardback4.jpg";
            levelCardList[4] = "img/cardback5.jpg";
            levelCardList[5] = "img/cardback6.jpg";
            levelCardList[6] = "img/cardback7.jpg";
            levelCardList[7] = "img/cardback8.jpg";
            levelCardList[8] = "img/cardback9.jpg";
            levelCardList[9] = "img/cardback10.jpg";
        
            var index = 0;
            switch(keyCode)
            {
                case tvKey.KEY_1:index = 0; break;
                case tvKey.KEY_2:index = 1; break;
                case tvKey.KEY_3:index = 2; break;
                case tvKey.KEY_4:index = 3; break;
                case tvKey.KEY_5:index = 4; break;
                case tvKey.KEY_6:index = 5; break;
                case tvKey.KEY_7:index = 6; break;
                case tvKey.KEY_8:index = 7; break;
                case tvKey.KEY_9:index = 8; break;
                case tvKey.KEY_0:index = 9; break;
            }
            
            if (openCardArray[index] == 0)
            {
                alert("open card check!!!");
                
                openCardArray[index] = 1;
                objectImageList[index].src = cardImageArray[index];
                
                if (gameStep == 1)
                {
                    gameStep = 2;
                    firstOpenCard = index;
                }
                else
                {
                    secondOpenCard = index;
                    
                    alert("same card check!!!");
                    if (cardNumberArray[firstOpenCard] == cardNumberArray[secondOpenCard])
                    {
                        alert(cardNumberArray[firstOpenCard]+"/"+cardNumberArray[secondOpenCard]);

                        gameStep = 1;
                        
                        //만일 모든 카드가 열려 있으면 성공한 것이다.
                        var flag = 0;
                        for (i = 0; i < 10; i++)
                        {
                            if (openCardArray[i] == 0)
                            {
                                flag = 1;
                                break;
                            }
                        }
                        
                        if (flag == 0)
                        {
                            gameStep = 0;
                            gameRemainTime = 60;
                            firstOpenCard = -1;
                            secondOpenCard = -1;
                            
                            setTimeout("Main.startGame()", 1000);
                        }
                    }
                    else
                    {
                        alert("wrong !!!");
                        gameStep = 3;
                        
                        if (gameRemainTime > 0)
                        {
                            gameRemainTime--;
                            
                            objectName = document.getElementById("game_remain_time");
                            objectName.innerText = "남은 시간 : "+gameRemainTime+"초";
                            
                            setTimeout("Main.closeOpenCard()", 1000);
                        }
                        else
                        {
                            Main.gameComplete();
                        }
                    }
                    
                }
            }
        }
        break;
        
    case tvKey.KEY_RED:
        if (gameStep > 0 && gameStep < 5)
        {
            Main.gameComplete();
        } 
        break;
    }
}